﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Collections;

namespace PicToHexGUI
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() != DialogResult.OK)
                return;
            Bitmap image = new Bitmap(96, 64);
            StreamReader reader = new StreamReader(openFileDialog1.FileName);
            Stream readStream = reader.BaseStream;
            byte[] Input = new byte[readStream.Length];
            readStream.Position = 74;
            List<byte> bits = new List<byte>();
            for (int i = 1; i < 756; i++)
                bits.Add(Reverse((byte)readStream.ReadByte()));
            BitArray bitarray = new BitArray(bits.ToArray());
            for (int y = 0; y < 64; y++)
                for (int x = 0; x < 96; x++)
                {
                    try
                    {
                        image.SetPixel(x, y, bitarray[y * 96 + x] ? Color.Black : Color.White);
                    }
                    catch { }
                }
            pictureBox1.Image = image;
        }

        public byte Reverse(byte inByte)
        {
            byte result = 0x00;
            byte mask = 0x00;

            for (mask = 0x80;
                                BitConverter.ToInt32(new byte[] { mask, 0, 0, 0 }, 0) > 0;
                                mask >>= 1)
            {
                result >>= 1;
                byte tempbyte = (byte)(inByte & mask);
                if (tempbyte != 0x00)
                    result |= 0x80;
            }
            return (result);
        }

        static void Convert(string Picture, string OutputFile, string OnCalcName)
        {
            StreamReader reader = new StreamReader(Picture);
            Stream readStream = reader.BaseStream;
            byte[] Input = new byte[readStream.Length];
            readStream.Position = 74;
            string Output = "";
            for (int i = 1; i < 756; i++)
            {
                Output += ByteToHex((byte)readStream.ReadByte());
            }
            List<byte> buffer = new List<byte>();
            foreach (char c in Output)
            {
                buffer.Add((byte)c);
            }
            TIFile.Program8XP.Save8XP(false, buffer.ToArray(), OnCalcName, OutputFile);
            reader.Close();
        }

        public static string ConvertToHex(byte[] Input)
        {
            string hex = "";
            foreach (byte c in Input)
                hex += ByteToHex(c);
            return hex;
        }

        public static string ByteToHex(byte Byte)
        {
            int first = (int)Byte / 16;
            int second = (int)Byte % 16;
            return "0123456789ABCDEF".Substring(first, 1) +
                "0123456789ABCDEF".Substring(second, 1);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    Convert(openFileDialog1.FileName, saveFileDialog1.FileName, textBox2.Text);
                }
                catch
                {
                    MessageBox.Show("An error has occured.");
                }
            }
        }
    }
}
